//+------------------------------------------------------------------+
//|                                                     FTVCPRDL.mq4 |
//|        Fisher Transform Value Chart Past Regression Deviated Log |
//|                               Copyright  2009-2010, Julien Moog |
//|                                          julien.moog@lapsote.net |
//|                                                      Credits to: |
//|             2006, tageiger, aka fxid10t@yahoo.com (Todd Geiger) |
//|                             Mark W. Helweg and David C. Stendahl |
//|                                Smallcaps90 http://www.pro-at.com |
//|                         Copyright  2005, Luis Guilherme Damiani |
//|                                      http://www.damianifx.com.br |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 12
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 White
#property indicator_color4 White
#property indicator_color5 White
#property indicator_color6 White
#property indicator_color7 White
#property indicator_color8 Lime
//#property indicator_color9 Red
//#property indicator_color10 Red
//#property indicator_color11 Magenta
//#property indicator_color12 Lime
//Limites des surachats et des surventes
//#property  indicator_level1  8
//#property  indicator_level2  4
//#property  indicator_level3  -4
//#property  indicator_level4  -8

double vo[],vh[],vb[],vc[];
int p1=5;
//---- input parameters

int period=0;
/*default 0 means the channel will use the open time from "x" bars back on which ever time period 
the indicator is attached to.  one can change to 1,5,15,30,60...etc to "lock" the start time to a specific 
period, and then view the "locked" channels on a different time period...*/

extern int LR.length=500;   // bars back regression begins
extern double std.channel.1=1;        // 1st channel
extern double std.channel.2=2;        // 2nd channel
extern double std.channel.3=3;        // 3nd channel
extern int       lenth=10;
extern int       maxbars=2000;
extern int bbperiod = 20;
extern int bbdev = 2;
//---- indicator buffers
double mean.Buffer[];
double high.1.Buffer[];
double low.1.Buffer[];
double high.2.Buffer[];
double low.2.Buffer[];
double high.3.Buffer[];
double low.3.Buffer[];
double AuxBuffer[];

int init()  {
/*---- line shifts when drawing
   SetIndexShift(0,JawsShift);
   SetIndexShift(1,TeethShift);
   SetIndexShift(2,LipsShift);
//---- first positions skipped when drawing*/
   SetIndexDrawBegin(0,LR.length);
   SetIndexDrawBegin(1,LR.length);
   SetIndexDrawBegin(2,LR.length);
   SetIndexDrawBegin(3,LR.length);
   SetIndexDrawBegin(4,LR.length);
   SetIndexDrawBegin(5,LR.length);
   SetIndexDrawBegin(6,LR.length);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,mean.Buffer);
   SetIndexBuffer(1,high.1.Buffer);
   SetIndexBuffer(2,low.1.Buffer);
   SetIndexBuffer(3,high.2.Buffer);
   SetIndexBuffer(4,low.2.Buffer);
   SetIndexBuffer(5,high.3.Buffer);
   SetIndexBuffer(6,low.3.Buffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE,0); SetIndexArrow(0,158);
   SetIndexStyle(1,DRAW_NONE,0); SetIndexArrow(1,158);
   SetIndexStyle(2,DRAW_NONE,0); SetIndexArrow(2,158);
   SetIndexStyle(3,DRAW_NONE,0); SetIndexArrow(3,158);
   SetIndexStyle(4,DRAW_NONE,0); SetIndexArrow(4,158);
   SetIndexStyle(5,DRAW_NONE,0); SetIndexArrow(5,158);
   SetIndexStyle(6,DRAW_NONE,0); SetIndexArrow(6,158);
//---- index labels
   SetIndexLabel(0,"mean");
   SetIndexLabel(1,"1st Std up");
   SetIndexLabel(2,"1st Std down");
   SetIndexLabel(3,"2nd Std up");
   SetIndexLabel(4,"2nd Std down");
   SetIndexLabel(5,"3rd Std up");
   SetIndexLabel(6,"3rd Std down");  
   //IndicatorBuffers(4);
   //SetIndexBuffer(7, vo);
   SetIndexBuffer(7, vc);
   SetIndexStyle(7, DRAW_LINE, STYLE_SOLID, 1);    
   //SetIndexDrawBegin(7, p1);
   //SetIndexBuffer(8, vh);
   //SetIndexStyle(8, DRAW_LINE, STYLE_SOLID, 1);    
   //SetIndexDrawBegin(8, p1);
   //SetIndexBuffer(9, vb);
   //SetIndexStyle(9, DRAW_LINE, STYLE_SOLID, 1);    
   //SetIndexDrawBegin(9, p1);
   //SetIndexBuffer(10, vc);
   //SetIndexStyle(10, DRAW_LINE, STYLE_SOLID, 1);    
   //SetIndexDrawBegin(10, p1);    
   //SetIndexStyle(11,DRAW_LINE);
   //SetIndexBuffer(11,AuxBuffer);
   SetLevelValue(0,0.8);
   SetLevelValue(1,-0.8);
   SetLevelValue(2,0);
   ArrayInitialize(AuxBuffer,0); 
   #property indicator_minimum -0.9
   #property indicator_maximum 0.9
//---- initialization done
return(0);
}

int deinit() {
ObjectsDeleteAll(0,OBJ_ARROW);ObjectDelete(period+"m "+LR.length+" TL");
}
int start() {
   ObjectDelete(period+"m "+LR.length+" TL");
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
// Past Regression Deviated Log   
//---- main loop
   for(int i=0; i<limit; i++) {
//linear regression calculation
      int start.bar=i+LR.length, end.bar=i;
      int n=start.bar-end.bar+1;
//---- calculate price values.. Linear regression calculation
      double value=Close[end.bar];
      double a,b,c;
      double sumy=value;
      double sumx=0.0;
      double sumxy=0.0;
      double sumx2=0.0;
      for(int ii=1; ii<n; ii++)  {
         value=Close[end.bar+ii];
         sumy+=value;
         sumxy+=value*ii;
         sumx+=ii;
         sumx2+=ii*ii; }
      c=MathLog(sumx2)*n-sumx*sumx;
      if(c==0.0) return;
      b=(sumxy*n-sumx*sumy)/c;
      a=(sumy-MathLog(sumx)*b)/n;
      double LR.price.2=a;
      double LR.price.1=a+b*n;
      mean.Buffer[i]=NormalizeDouble(LR.price.2,Digits);
/*---- maximal deviation calculation (3rd deviation line)
      double max.dev=0;
      double deviation=0;
      double dvalue=a;
      for(int i.1=0; i.1<n; i.1++)   {
         value=Close[end.bar+i.1];
         dvalue+=b;
         deviation=MathAbs(value-dvalue);
         if(max.dev<=deviation) max.dev=deviation; } */  
//Linear regression trendline
      ObjectDelete(period+"m "+LR.length+" TL");
      ObjectCreate(period+"m "+LR.length+" TL",OBJ_TREND,0,Time[start.bar],LR.price.1,Time[end.bar],LR.price.2);
      ObjectSet(period+"m "+LR.length+" TL",OBJPROP_COLOR,Orange);
      ObjectSet(period+"m "+LR.length+" TL",OBJPROP_WIDTH,2);
      ObjectSet(period+"m "+LR.length+" TL",OBJPROP_RAY,false);
//...standard deviation...
      double x=0,x.sum=0,x.avg=0,x.sum.squared=0,std.dev=0;
      for(int iii=i; iii<start.bar; iii++)    {
         x=MathAbs(Close[iii]-ObjectGetValueByShift(period+"m "+LR.length+" TL",iii));
         x.sum.squared+=(x*x);   }
         std.dev=MathSqrt(x.sum.squared/((start.bar-end.bar)-1));
      //Print("LR.price.1 ",LR.price.1,"  LR.Price.2 ",LR.price.2," std.dev ",std.dev);

//...standard deviation channels...
high.1.Buffer[i]=mean.Buffer[i]+(std.channel.1*std.dev);
low.1.Buffer[i]=mean.Buffer[i]-(std.channel.1*std.dev);
high.2.Buffer[i]=mean.Buffer[i]+(std.channel.2*std.dev);
low.2.Buffer[i]=mean.Buffer[i]-(std.channel.2*std.dev);
high.3.Buffer[i]=mean.Buffer[i]+(std.channel.3*std.dev);//max.dev;
low.3.Buffer[i]=mean.Buffer[i]-(std.channel.3*std.dev);//max.dev;
}

// Value Chart   
   double m1,dvu;   
   if(Bars<=p1) return(0);
//---- initial zero
   if(counted_bars<1)
      {
      for(i=1;i<=p1;i++) 
         {
         vo[Bars-i]=0.0;   
         vh[Bars-i]=0.0;   
         vb[Bars-i]=0.0;   
         vc[Bars-i]=0.0;            
         }
      }
//----
   i=Bars-p1-1;
   if(counted_bars>=p1) i=Bars-counted_bars-1;
   while(i>=0)
      {
      //Ligne moyenne sur P1 (=5) jours
      m1=0.5*(high.3.Buffer[i]+low.3.Buffer[i]);
      m1=m1+0.5*(high.3.Buffer[i+1]+low.3.Buffer[i+1]);
      m1=m1+0.5*(high.3.Buffer[i+2]+low.3.Buffer[i+2]);
      m1=m1+0.5*(high.3.Buffer[i+3]+low.3.Buffer[i+3]);
      m1=m1+0.5*(high.3.Buffer[i+4]+low.3.Buffer[i+4]);
      m1=m1/5; 
      //Dynamic Volatility Units     
      dvu=(high.3.Buffer[i]-low.3.Buffer[i]);
      dvu=dvu+(high.3.Buffer[i+1]-low.3.Buffer[i+1]);
      dvu=dvu+(high.3.Buffer[i+2]-low.3.Buffer[i+2]);
      dvu=dvu+(high.3.Buffer[i+3]-low.3.Buffer[i+3]);
      dvu=dvu+(high.3.Buffer[i+4]-low.3.Buffer[i+4]);
      dvu=dvu/5;
      dvu=dvu*0.2;
      //Valeurs relatives des ouvertures, des hautes, 
      //des basses et des clotures
      vo[i]=Open[i]-m1;      
      vh[i]=high.3.Buffer[i]-m1;
      vb[i]=low.3.Buffer[i]-m1;
      vc[i]=Close[i]-m1;
      //Correction par les DVU
      if (dvu!=0)
         {
         vo[i]=vo[i]/dvu;
         vh[i]=vh[i]/dvu;
         vb[i]=vb[i]/dvu;
         vc[i]=vc[i]/dvu;  
         // Fisher Transform       
         vc[i]=0.5*((vc[i]+4)*12.5/100-0.5)*2+0.5*vc[i+1];
         
         }
      else
         {
         vo[i]=0;
         vh[i]=0;
         vb[i]=0;
         vc[i]=0;    
         // Fisher Transform     
         vc[i]=0.5*((vc[i]+4)*12.5/100-0.5)*2+0.5*vc[i+1];  
               
         }  
      //Autre adaptation possible avec des points
      /* 
      if (vh>l1) pth=vh;
      if (vh>l2 && vh<l1) pmh=vh;
      if (vb<l4) ptb=vb;
      if (vb<l3 && vb>l4) pmb=vb;   
      */ 
      i--;        
      }

// Fisher Transform
//if(counted_bars<0) return(-1);      
      //if(limit>maxbars)limit=maxbars;      
      ////if (limit>Bars-lenth-1)limit=Bars-lenth-1;   
      ////---- 
      //for (int shift = limit; shift>=0;shift--)
      //{
	      //AuxBuffer[shift]=0.5*((vc[shift]+4)*12.5/100-0.5)*2+0.5*AuxBuffer[shift+1]; 	               
       //}

return(0);
}
//+------------------------------------------------------------------+